%{
#include "assembleur_ksi.h"
#include "consts.h"
#include "assembleur_ksi.tab.h"
int numligne = 1;
%}
integer    [0-9]+
memtype    [PM]
eol        \n
separator  [ \t]+
label      [a-zA-Z][a-zA-Z_0-9]+
%%
DONNEES    { yylval.valeur = DONNEES;  return TOK_DONNEES; }
AFFECTE\+  { yylval.valeur = AFFECTEP; return TOK_AFFECTE; }
AFFECTE	   { yylval.valeur = AFFECTE;  return TOK_AFFECTE; }
AFFECTESP  { yylval.valeur = AFFECTESP; return TOK_AFFECTE; }
SI	   { yylval.valeur = SI;       return TOK_SAUT; }
SAUT	   { yylval.valeur = SAUT;     return TOK_SAUT; }
CPILE	   { yylval.valeur = CPILE;    return TOK_PILE; }
DPILE	   { yylval.valeur = DPILE;    return TOK_PILE; }
APPEL	   { yylval.valeur = APPEL;    return TOK_APPEL; }
RETOUR	   { yylval.valeur = RETOUR;   return TOK_RETOUR; }
TEST	   { yylval.valeur = TEST;     return TOK_TEST; }
TRAPPE	   { yylval.valeur = TRAPPE;   return TOK_TRAPPE; }
CLONE	   { yylval.valeur = CLONE;    return TOK_CTRAPPE; }
RECOUVRE   { yylval.valeur = RECOUVRE; return TOK_CTRAPPE; }
ATTENDS	   { yylval.valeur = ATTENDS;  return TOK_CTRAPPE; }
FIN	   { yylval.valeur = FIN;      return TOK_CTRAPPE; }
CAPTURE	   { yylval.valeur = CAPTURE;  return TOK_CTRAPPE; }
EMETS	   { yylval.valeur = EMETS;    return TOK_CTRAPPE; }
ID	   { yylval.valeur = ID;       return TOK_CTRAPPE; }
IDP	   { yylval.valeur = IDP;      return TOK_CTRAPPE; }
LIT	   { yylval.valeur = LIT;      return TOK_CTRAPPE; }
ECRIT	   { yylval.valeur = ECRIT;    return TOK_CTRAPPE; }
\#{integer} { 
             yylval.reference[0] = 0; yylval.reference[1] = atoi(yytext+1);
             return CONSTANTE; }

[\*]?{memtype}{integer} {
             static char *text;

             text = yytext;
	     yylval.reference[0] = 0;
	     if (text[0]=='*') {
	       SET_INDIRECT(yylval.reference[0]);
	       text++;
	     }
	     switch(text[0]) {
	     case 'P':
	       SET_PILE(yylval.reference[0]);
	       break;
	     case 'M':
	       break;
	     }
	     SET_NOTCONSTANT(yylval.reference[0]);
	     yylval.reference[1] = atoi(text+1);
	     return REFERENCE;
	   }

{label}    {
             if (strlen(yytext)>LABEL_MAX) {
	       fprintf(stderr,"Attention les etiquettes sont limitees a %d caracteres (%s)\n",LABEL_MAX,yytext);
	       strncpy(yylval.label,yytext,LABEL_MAX);
             } 
             else {
	       strcpy(yylval.label,yytext);
	     }
	     return LABEL; }
{separator}  { return SEPARATOR; }
{separator}\/\/.*{eol} { numligne++; return EOL; }
{eol}        { numligne++; return EOL; }
.	     { return yytext[0]; }
%%
yyerror(const char *msg) {
  fprintf(stderr,"Erreur de syntaxe en ligne %d (%s)\n",numligne,yytext);
  exit(1);
}
